﻿<UserControl x:Class="CMS.Views.MedicalAppointmentView"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:dxe="http://schemas.devexpress.com/winfx/2008/xaml/editors"
             xmlns:dxg="http://schemas.devexpress.com/winfx/2008/xaml/grid"
             xmlns:dxb="http://schemas.devexpress.com/winfx/2008/xaml/bars"
             xmlns:dxr="http://schemas.devexpress.com/winfx/2008/xaml/ribbon"
             xmlns:dxlc="http://schemas.devexpress.com/winfx/2008/xaml/layoutcontrol"
             xmlns:dxmvvm="http://schemas.devexpress.com/winfx/2008/xaml/mvvm"
             xmlns:viewModel="clr-namespace:CMS.ViewModels"
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
             xmlns:dx="http://schemas.devexpress.com/winfx/2008/xaml/core"
             xmlns:dxsch="http://schemas.devexpress.com/winfx/2008/xaml/scheduling"
             xmlns:dxscht="http://schemas.devexpress.com/winfx/2008/xaml/scheduling/themekeys"
             mc:Ignorable="d" d:DesignHeight="400" d:DesignWidth="600" DataContext="{dxmvvm:ViewModelSource viewModel:MedicalAppointmentViewModel}">
    <UserControl.Resources>
        <ResourceDictionary Source="../../Resources/EntityViewResources.xaml" />
    </UserControl.Resources>
    <DockPanel Style="{StaticResource EntityView.RootContainer}">
        <dxr:RibbonControl DockPanel.Dock="Top" Style="{StaticResource EntityView.RibbonControl}" ShowApplicationButton="False" ToolbarShowMode="Hide">
            <dxr:RibbonDefaultPageCategory>
                <dxr:RibbonPage Style="{StaticResource EntityView.RibbonPage}">
                    <dxr:RibbonPageGroup Style="{StaticResource EntityView.RibbonPageGroup.Main}">
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Save}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.SaveAndClose}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.SaveAndNew}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Reset}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Delete}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Close}" />
                    </dxr:RibbonPageGroup>
                    <dxr:RibbonPageGroup Style="{StaticResource EntityView.RibbonPageGroup.Layout}">
                        <dxb:BarCheckItem Style="{StaticResource EntityView.Command.Customize}" IsChecked="{Binding IsCustomization, ElementName=layoutControl}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.SaveLayout}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.ResetLayout}" />
                    </dxr:RibbonPageGroup>
                </dxr:RibbonPage>
            </dxr:RibbonDefaultPageCategory>
        </dxr:RibbonControl>
        <dxr:RibbonStatusBarControl DockPanel.Dock="Bottom" Style="{StaticResource EntityView.RibbonStatusBar}" />
        <dxlc:LayoutControl x:Name="layoutControl" Orientation="Vertical" dxe:ValidationService.IsValidationContainer="True" Style="{StaticResource EntityView.LayoutControl}">
            <dxlc:DataLayoutItem x:Name="layoutItemDoctor" Binding="{Binding Entity.Doctor, Mode=OneTime}" Label="Doctor">
                <dxg:LookUpEdit 
                    Style="{StaticResource EntityView.DoctorsLookUpEdit}"
                    EditValue="{Binding Entity.DoctorID,Mode=TwoWay, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                    ItemsSource="{Binding LookUpDoctors.Entities}" 
                    ValueMember="DoctorID" 
                    DisplayMember="Name"/>
            </dxlc:DataLayoutItem>
            <dxlc:DataLayoutItem x:Name="layoutItemPatient" Binding="{Binding Entity.Patient, Mode=OneTime}" Label="Patient">
                <dxg:LookUpEdit Style="{StaticResource EntityView.PatientsLookUpEdit}"
                                EditValue="{Binding Entity.PatientID,Mode=TwoWay, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                                ItemsSource="{Binding LookUpPatients.Entities}" 
                                ValueMember="PatientID" 
                                DisplayMember="Name" 
                                EditValueChanged="{DXEvent 'PatientChanged(@args)'}"/>
            </dxlc:DataLayoutItem>
            <dxlc:DataLayoutItem x:Name="layoutItemMedicationType" Binding="{Binding Entity.MedicationType, Mode=OneTime}" Label="Medication Type">
                <dxg:LookUpEdit Style="{StaticResource EntityView.MedicationTypesLookUpEdit}"
                                EditValue="{Binding Entity.MedicationTypeID,Mode=TwoWay, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                                ItemsSource="{Binding LookUpMedicationTypes.Entities}"
                                ValueMember="MedicationTypeID" 
                                DisplayMember="Description" 
                                EditValueChanged="{DXEvent 'TypeChanged(@args)'}"/>
            </dxlc:DataLayoutItem>
            <dxlc:LayoutItem x:Name="layoutItemLocation" Label="Location" >
                <dxg:LookUpEdit Style="{StaticResource EntityView.AppointmentLocationsLookUpEdit}"
                                EditValue="{Binding Entity.AppointmentLocationID,Mode=TwoWay, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                                ItemsSource="{Binding LookUpAppointmentLocations.Entities}" 
                                ValueMember="AppointmentLocationID"
                                DisplayMember="Caption"                               
                                EditValueChanged="{DXEvent 'LocationChanged(@args)'}"/>
            </dxlc:LayoutItem>
            <dxlc:LayoutItem x:Name="layoutItemPaymentStatus" Label="Payment Status">
                <dxg:LookUpEdit Style="{StaticResource EntityView.PaymentStatusLookUpEdit}"
                                EditValue="{Binding Entity.PaymentStateID,Mode=TwoWay, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                                ItemsSource="{Binding LookUpPaymentStates.Entities}"
                                ValueMember="PaymentStateID"
                                DisplayMember="Caption"/>
            </dxlc:LayoutItem>
            <dxlc:LayoutItem x:Name="layoutItemImportance" Label="Importance">
                <dxg:LookUpEdit Style="{StaticResource EntityView.AppointmentImportancesLookUpEdit}"
                                EditValue="{Binding Entity.AppointmentImportanceID,Mode=TwoWay, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                                ItemsSource="{Binding LookUpAppointmentImportances.Entities}" 
                                ValueMember="AppointmentImportanceID"
                                DisplayMember="Caption"/>
            </dxlc:LayoutItem>
            <dxlc:LayoutItem x:Name="layoutItemAllDay" Label="All Day?" >
                <dxe:CheckEdit EditValue="{Binding Entity.AllDay, Mode=TwoWay, UpdateSourceTrigger=PropertyChanged}"/>
            </dxlc:LayoutItem>
            <dxlc:LayoutItem x:Name="layoutItemStartAt" Label="Start At">
                <dxe:DateEdit  Mask="G" MaskUseAsDisplayFormat="True" EditValue="{Binding Entity.StartTime, Mode=TwoWay, ValidatesOnDataErrors=True, UpdateSourceTrigger=PropertyChanged}" AllowNullInput="True" >
                    <dxe:DateEdit.StyleSettings>
                        <dxe:DateEditNavigatorWithTimePickerStyleSettings/>
                    </dxe:DateEdit.StyleSettings>
                </dxe:DateEdit>
            </dxlc:LayoutItem>
            <dxlc:LayoutItem x:Name="layoutItemEndAte" Label="Ends At">
                <dxe:DateEdit  Mask="G" MaskUseAsDisplayFormat="True" EditValue="{Binding Entity.EndTime, Mode=TwoWay, ValidatesOnDataErrors=True, UpdateSourceTrigger=PropertyChanged}">
                    <dxe:DateEdit.StyleSettings>
                        <dxe:DateEditNavigatorWithTimePickerStyleSettings/>
                    </dxe:DateEdit.StyleSettings>
                </dxe:DateEdit>
            </dxlc:LayoutItem>
            <dxlc:LayoutGroup Margin="0,5,0,0" Orientation="Vertical" HorizontalAlignment="Stretch" View="Tabs">
                <dxlc:LayoutGroup Header="Treatments" Orientation="Vertical">
                    <dxlc:LayoutGroup Orientation="Horizontal" Height="30" VerticalAlignment="Top">
                        <dxlc:LayoutItem Label="Sale Item" >
                            <dxg:LookUpEdit
                                AutoPopulateColumns="False" 
                                EditValue="{Binding SelectedSaleItem, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}" 
                                ItemsSource="{Binding SaleItems}"
                                Style="{StaticResource EntityView.SaleItemsLookUpEdit}"
                                DisplayMember="Name"
                                PopupMinHeight="100" 
                                PopupHeight="150"/>
                        </dxlc:LayoutItem>
                        <dxlc:LayoutItem Label="Quantity" Width="100">
                            <dxe:TextEdit EditValue="{Binding Quantity, UpdateSourceTrigger=PropertyChanged , Mode=TwoWay}" MaskType="Numeric" Mask="d0"  MaskUseAsDisplayFormat="True"/>
                        </dxlc:LayoutItem>
                        <dxlc:LayoutItem Width="50">
                            <Button Content="Add" Command="{Binding AddToTreatmentsCommand}"/>
                        </dxlc:LayoutItem>
                        <dxlc:LayoutItem  Label="Total">
                            <dxe:TextEdit HorizontalContentAlignment="Left" MaskUseAsDisplayFormat="True"
                                   Mask="d0" MaskType="Numeric"
                                   EditValue="{Binding Entity.TotalAmount,Mode=OneWay, UpdateSourceTrigger=PropertyChanged , ValidatesOnDataErrors=True}"
                                   IsReadOnly="True"/>
                        </dxlc:LayoutItem>
                    </dxlc:LayoutGroup>
                    <dxg:GridControl x:Name="gridControl" ItemsSource="{Binding Entity.Treatments}">
                        <dxg:GridControl.View>
                            <dxg:TableView  ShowGroupPanel="False" AllowGrouping="False" ShowFilterPanelMode="Never" ShowSearchPanelMode="Never" ShowIndicator="False" AutoWidth="True" VerticalScrollbarVisibility="Auto">
                                <dxmvvm:Interaction.Behaviors>
                                    <dxmvvm:EventToCommand PassEventArgsToCommand="True" Command="{Binding Path=DataContext.UpdateItemQuantityCommand,RelativeSource={RelativeSource AncestorType={x:Type UserControl}}}" EventName="CellValueChanged">
                                        <dxmvvm:EventToCommand.EventArgsConverter>
                                            <dx:EventArgsToDataRowConverter/>
                                        </dxmvvm:EventToCommand.EventArgsConverter>
                                    </dxmvvm:EventToCommand>
                                </dxmvvm:Interaction.Behaviors>
                            </dxg:TableView>
                        </dxg:GridControl.View>
                        <dxg:GridControl.Columns>
                            <dxg:GridColumn IsSmart="True" FieldName="SaleItem.Name" Header="Item" AllowEditing="False"/>
                            <dxg:GridColumn IsSmart="True" FieldName="Quantity" AllowEditing="true">
                                <dxg:GridColumn.EditSettings>
                                    <dxe:SpinEditSettings Mask="d0" MinValue="0" HorizontalContentAlignment="Center"/>
                                </dxg:GridColumn.EditSettings>
                            </dxg:GridColumn>
                            <dxg:GridColumn IsSmart="True" FieldName="Price" AllowEditing="True">
                                <dxg:GridColumn.CellTemplate>
                                    <DataTemplate>
                                        <dxe:TextEdit  Mask="d0" MaskType="Numeric" HorizontalAlignment="Center" EditMode="InplaceActive"  IsReadOnly="True" EditValue="{Binding RowData.Row.Price ,Mode=TwoWay}" MaskUseAsDisplayFormat="True"/>
                                    </DataTemplate>
                                </dxg:GridColumn.CellTemplate>
                            </dxg:GridColumn>
                            <dxg:GridColumn  Width="50" MinWidth="50" MaxWidth="50" AllowEditing="False">
                                <dxg:GridColumn.DisplayTemplate>
                                    <ControlTemplate>
                                        <Grid>
                                        <Button    Style="{StaticResource DeleteButton}"  Height="20" HorizontalAlignment="Center"
                                                   Command="{Binding Path=DataContext.DeleteTreatmentCommand,RelativeSource={RelativeSource AncestorType={x:Type UserControl}}}"
                                                   CommandParameter="{Binding RowData.Row}"/>
                                        </Grid>
                                    </ControlTemplate>
                                </dxg:GridColumn.DisplayTemplate>
                            </dxg:GridColumn>
                        </dxg:GridControl.Columns>
                    </dxg:GridControl>
                </dxlc:LayoutGroup>
                <dxlc:LayoutGroup Header="Additional Information">
                    <dxlc:LayoutItem VerticalAlignment="Stretch">
                        <dxe:TextEdit EditValue="{Binding Entity.Note, Mode=TwoWay, UpdateSourceTrigger=PropertyChanged}" x:Name="editorDescription" AcceptsReturn="True" VerticalContentAlignment="Top"/>
                    </dxlc:LayoutItem>
                </dxlc:LayoutGroup>
            </dxlc:LayoutGroup>
        </dxlc:LayoutControl>
    </DockPanel>
</UserControl>